;Copyright (c) 1999 Matthew Belmonte
;code excerpted from fastshft.asm by Matthew Belmonte
;see also istop.asm, cominit.asm
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
TITLE	  ISTART		START ISCAN RECORDING
CODESG	  SEGMENT PARA 'Code'
	  ASSUME CS:CODESG,DS:CODESG,SS:CODESG,ES:CODESG
	  ORG 100H		;START AT END OF PSP
MAIN:	  MOV DS,0040H		;BIOS SEGMENT
	  MOV DX,[00H]		;GET ADDRESS OF BASE SERIAL PORT (COM1)
	  MOV BX,[10H]		;GET DEVICE COUNTS
	  AND BH,0CH		;MASK FOR HIGH-ORDER BITS OF SERIAL PORT COUNT
	  JE ONEPORT		;IF MORE THAN ONE SERIAL PORT IS INSTALLED,
	  MOV DX,[02H]		;GET ADDRESS OF FIRST EXPANSION PORT (COM2)
ONEPORT:  ADD DX,3		;POINT TO CONTROL REGISTER
	  MOV AL,83H		;ENABLE WRITES TO BAUD RATE REGISTER
	  OUT DX,AL
	  SUB DX,2
	  MOV AL,0		;BAUD RATE DIVISOR HIGH = 0
	  OUT DX,AL
	  DEC DX
	  MOV AL,06H		;BAUD RATE DIVISOR LOW = 6
	  OUT DX,AL
	  ADD DX,3
	  MOV AL,03H		;DISABLE BAUD WRITES, SET 8N1
	  OUT DX,AL
	  SUB DX,3		;POINT AT DATA REGISTER
	  MOV AL,84H
	  OUT DX,AL		;SET OUTPUT
	  MOV AX,4C00H		;SUCCESSFUL COMPLETION
	  INT 21H		;RETURN TO MSDOS
	  ENDP
CODESG	  ENDS
	  END  MAIN
